<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: ChangeLog</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.7.1</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">ChangeLog </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><h3>v1.7.1 released 05/04/2018:</h3>
<p><b>Enhancements</b></p><ul>
<li>Added the Bluetooth interface, which manages the Bluetooth connection between Alexa-enabled products and peer devices. This release supports <code>A2DP-SINK</code> and <code>AVRCP</code> profiles. <b>Note</b>: Bluetooth is optional and is currently limited to Raspberry Pi and Linux platforms.</li>
<li>Added new <a href="https://github.com/alexa/avs-device-sdk/wiki/Dependencies#bluetooth-dependencies">Bluetooth dependencies</a> for Linux and Raspberry Pi.</li>
<li>Device Capability Framework (<code>DCF</code>) renamed to <code>Capabilities</code>.</li>
<li>Updated the non-CBL client ID error message to be more specific.</li>
<li>Updated the sample app to enter a limited interaction mode after an unrecoverable error.</li>
</ul>
<p><b>Bug Fixes</b></p><ul>
<li><a href="https://github.com/alexa/avs-device-sdk/issues/597">Issue 597</a> - Fixed a bug where the sample app did not respond to locale change settings.</li>
<li>Fixed issue where GStreamer 1.14 <code>MediaPlayerTest</code> failed on Windows.</li>
<li>Fixed an issue where a segmentation fault was triggered after unrecoverable error handling.</li>
</ul>
<p><b>Known Issues</b></p><ul>
<li>The <code>ACL</code> may encounter issues if audio attachments are received but not consumed.</li>
<li><code>SpeechSynthesizerState</code> currently uses <code>GAINING_FOCUS</code> and <code>LOSING_FOCUS</code> as a workaround for handling intermediate state. These states may be removed in a future release.</li>
<li>The Alexa app doesn't always indicate when a device is successfully connected via Bluetooth.</li>
<li>Connecting a product to streaming media via Bluetooth will sometimes stop media playback within the source application. Resuming playback through the source application or toggling next/previous will correct playback.</li>
<li>When streaming silence via Bluetooth, the Alexa companion app will sometimes indicate that media content is streaming.</li>
<li>The Bluetooth agent assumes that the Bluetooth adapter is always connected to a power source. Disconnecting from a power source during operation is not yet supported.</li>
<li>On some products, interrupted Bluetooth playback may not resume if other content is locally streamed.</li>
<li>When streaming content via Bluetooth, under certain conditions playback will fail to resume and the sample app hangs on exit. This is due to a conflict between the <code>GStreamer</code> pipeline and the Bluetooth agent.</li>
<li>On Raspberry Pi, when streaming audio via Bluetooth, sometimes the audio stream stutters.</li>
<li>On Raspberry Pi, <code>BlueALSA</code> must be terminated each time the device boots. See <a href="https://github.com/alexa/avs-device-sdk/wiki/Raspberry-Pi-Quick-Start-Guide-with-Script#bluetooth">Raspberry Pi Quick Start Guide</a> for more information.</li>
</ul>
<h3>v1.7.0 released 04/18/2018:</h3>
<p><b>Enhancements</b></p><ul>
<li><code>AuthDelegate</code> and <code>AuthServer.py</code> have been replaced by <code>CBLAUthDelegate</code>, which uses Code Based Linking for authorization.</li>
<li>Added new properties to <code>AlexaClientSDKConfig</code>:<ul>
<li><a href="https://github.com/alexa/avs-device-sdk/blob/master/Integration/AlexaClientSDKConfig.json#L2"><code>cblAuthDelegate</code></a> - This object specifies parameters for <code>CBLAuthDelegate</code>.</li>
<li><a href="https://github.com/alexa/avs-device-sdk/blob/master/Integration/AlexaClientSDKConfig.json#L34"><code>miscDatabase</code></a> - A generic key/value database to be used by various components.</li>
<li><a href="https://github.com/alexa/avs-device-sdk/blob/master/Integration/AlexaClientSDKConfig.json#L17"><code>dcfDelegate</code></a> - This object specifies parameters for <code>DCFDelegate</code>. Within this object, values were added for <code>endpoint</code> and <code>overridenDcfPublishMessageBody</code>. <code>endpoint</code> is the endpoint for the Capabilities API. <code>overridenDcfPublishMessageBody</code>is the message that is sent to the Capabilities API. <b>Note</b>: Values in the <code>dcfDelegate</code> object will only work in <code>DEBUG</code> builds.</li>
<li><a href="https://github.com/alexa/avs-device-sdk/blob/master/Integration/AlexaClientSDKConfig.json#L9"><code>deviceInfo</code></a> - Specifies device-identifying information for use by the Capabilities API and <code>CBLAuthDelegate</code>.</li>
</ul>
</li>
<li>Updated Directive Sequencer to support wildcard directive handlers. This allows a handler for a given AVS interface to register at the namespace level, rather than specifying the names of all directives within a given namespace.</li>
<li>Updated the Raspberry Pi installation script to include <code>alsasink</code> in <code>AlexaClientSDKConfig</code>.</li>
<li>Added <code>audioSink</code> as a configuration option. This allows users to override the audio sink element used in <code>Gstreamer</code>.</li>
<li>Added an interface for monitoring internet connection status: <code><a class="el" href="_internet_connection_monitor_interface_8h.html">InternetConnectionMonitorInterface.h</a></code>.</li>
<li>The Alexa Communications Library (ACL) is no longer required to wait until authorization has succeeded before attempting to connect to AVS. Instead, <code>HTTP2Transport</code> handles waiting for authorization to complete.</li>
<li>Device capabilities can now be sent for each capability interface using the Capabilities API.</li>
<li>The sample app has been updated to send Capabilities API messages, which are automatically sent when the sample app starts. <b>Note</b>: A successful call to the Capabilities API must occur before a connection with AVS is established.</li>
<li>The SDK now supports HTTP PUT messages.</li>
<li>Added support for opt-arg style arguments and multiple configuration files. Now, the sample app can be invoked by either of these commands: <code>SampleApp &lt;configfile&gt; &lt;debuglevel&gt;</code> OR <code>SampleApp -C file1 -C file2 ... -L loglevel</code>.</li>
</ul>
<p><b>Bug Fixes</b></p><ul>
<li>Fixed Issues <a href="https://github.com/alexa/avs-device-sdk/issues/447">447</a> and <a href="https://github.com/alexa/avs-device-sdk/issues/553">553</a>.</li>
<li>Fixed the <code>AttachmentRenderSource</code>'s handling of <code>BLOCKING</code> <code>AttachmentReaders</code>.</li>
<li>Updated the <code>Logger</code> implementation to be more resilient to <code>nullptr</code> string inputs.</li>
<li>Fixed a <code>TimeUtils</code> utility-related compile issue.</li>
<li>Fixed a bug in which alerts failed to activate if the system was restarted without network connection.</li>
<li>Fixed Android 64-bit build failure issue.</li>
</ul>
<p><b>Known Issues</b></p><ul>
<li>The <code>ACL</code> may encounter issues if audio attachments are received but not consumed.</li>
<li><code>SpeechSynthesizerState</code> currently uses <code>GAINING_FOCUS</code> and <code>LOSING_FOCUS</code> as a workaround for handling intermediate state. These states may be removed in a future release.</li>
<li>Some ERROR messages may be printed during start-up even if initialization proceeds normally and successfully.</li>
<li>If an unrecoverable authorization error is encountered the sample app may crash on shutdown.</li>
<li>If a non-CBL <code>clientId</code> is included in the <code>deviceInfo</code> section of <code>AlexaClientSDKConfig.json</code>, the error will be reported as an unrecoverable authorization error, rather than a more specific error.</li>
</ul>
<h3>[1.6.0] - 2018-03-08</h3>
<p><b>Enhancements</b></p><ul>
<li><code>rapidJson</code> is now included with "make install".</li>
<li>Updated the <code>TemplateRuntimeObserverInterface</code> to support clearing of <code>displayCards</code>.</li>
<li>Added Windows SDK support, along with an installation script (MinGW-w64).</li>
<li>Updated <code>ContextManager</code> to ignore context reported by a state provider.</li>
<li>The <code>SharedDataStream</code> object is now associated by playlist, rather than by URL.</li>
<li>Added the <code>RegistrationManager</code> component. Now, when a user logs out all persistent user-specific data is cleared from the SDK. The log out functionality can be exercised in the sample app with the new command: <code>k</code>.</li>
</ul>
<p><b>Bug Fixes</b></p><ul>
<li><a href="https://github.com/alexa/avs-device-sdk/issues/400">Issue 400</a> Fixed a bug where the alert reminder did not iterate as intended after loss of network connection.</li>
<li><a href="https://github.com/alexa/avs-device-sdk/issues/477">Issue 477</a> Fixed a bug in which Alexa's weather response was being truncated.</li>
<li>Fixed an issue in which there were reports of instability related to the Sensory engine. To correct this, the <code>portAudio</code> <a href="https://github.com/alexa/avs-device-sdk/blob/master/Integration/AlexaClientSDKConfig.json#L62"><code>suggestedLatency</code></a> value can now be configured.</li>
</ul>
<p><b>Known Issues</b></p><ul>
<li>The <code>ACL</code> may encounter issues if audio attachments are received but not consumed.</li>
<li><code>SpeechSynthesizerState</code> currently uses <code>GAINING_FOCUS</code> and <code>LOSING_FOCUS</code> as a workaround for handling intermediate state. These states may be removed in a future release.</li>
<li>Music playback doesn't immediately stop when a user barges-in on iHeartRadio.</li>
<li>The Windows sample app hangs on exit.</li>
<li>GDB receives a <code>SIGTRAP</code> when troubleshooting the Windows sample app.</li>
<li><code>make integration</code> doesn't work on Windows. Integration tests will need to be run individually.</li>
</ul>
<h3>[1.5.0] - 2018-02-12</h3>
<p><b>Enhancements</b></p><ul>
<li>Added the <code>ExternalMediaPlayer</code> Capability Agent. This allows playback from music providers that control their own playback queue. Example: Spotify.</li>
<li>Added support for AU and NZ to the <code>SampleApp</code>.</li>
<li>Firmware version can now be sent to Alexa via the <code>SoftwareInfo</code> event. The firmware version is specified in the config file under the <code>sampleApp</code> object as an integer value named <a href="https://github.com/alexa/avs-device-sdk/blob/master/Integration/AlexaClientSDKConfig.json#L52"><code>firmwareVersion</code></a>.</li>
<li>The new <code>f</code> command was added to the <code>SampleApp</code> which allows the firmware version to be updated at run-time.</li>
<li>Optional configuration changes have been introduced. Now a <a href="https://github.com/alexa/avs-device-sdk/blob/master/Integration/AlexaClientSDKConfig.json#L93">default log level</a> can be set for <code>ACSDK_LOG_MODULE</code> components, globally or individually. This value is specified under a new root level configuration object called <code>logger</code>, and the value itself is named <code>logLevel</code>. This allows you to limit the degree of logging to that default value, such as <code>ERROR</code>or <code>INFO</code>.</li>
</ul>
<p><b>Bug Fixes</b></p><ul>
<li>Fixed bug where <code>AudioPlayer</code> progress reports were not being sent, or were being sent incorrectly.</li>
<li><a href="https://github.com/alexa/avs-device-sdk/issues/408">Issue 408</a> - Irrelevant code related to <code>UrlSource</code> was removed from the <code>GStreamer-based MediaPlayer</code> implementation.</li>
<li>The <code>TZ</code> variable no longer needs to be set to <code>UTC</code> when building the <code>SampleApp</code>.</li>
<li>Fixed a bug where <code>CurlEasyHandleWrapper</code> logged unwanted data on failure conditions.</li>
<li>Fixed a bug to improve <code>SIGPIPE</code> handling.</li>
<li>Fixed a bug where the filename and classname were mismatched. Changed <code>UrlToAttachmentConverter.h</code> to <code><a class="el" href="_url_content_to_attachment_converter_8h.html">UrlContentToAttachmentConverter.h</a></code>,and <code>UrlToAttachmentConverter.cpp</code> to <code><a class="el" href="_url_content_to_attachment_converter_8cpp.html">UrlContentToAttachmentConverter.cpp</a></code>.</li>
<li>Fixed a bug where after muting and then un-muting the GStreamer-based <code>MediaPlayer</code> implementation, the next item in queue would play instead of continuing playback of the originally muted item.</li>
</ul>
<p><b>Known Issues</b></p><ul>
<li>The <code>ACL</code> may encounter issues if audio attachments are received but not consumed.</li>
<li>Display Cards for Kindle don't render.</li>
<li><code>SpeechSynthesizerState</code> currently uses <code>GAINING_FOCUS</code> and <code>LOSING_FOCUS</code> as a workaround for handling intermediate state. These states may be removed in a future release.</li>
<li>Music playback doesn't immediately stop when a user barges-in on iHeartRadio.</li>
</ul>
<h3>[1.4.0] - 2018-01-12</h3>
<p><b>Enhancements</b></p><ul>
<li>Added the Notifications Capability Agent. This allows a client to receive notification indicators from Alexa.</li>
<li>Added support for the <code>SoftwareInfo</code> event. This code is triggered in the <code>SampleApp</code> by providing a positive decimal integer as the "firmwareVersion" value in "sampleApp" object of the <code>AlexaClientSDKConfig.json</code>. The reported firmware version can be updated after starting the <code>SampleApp</code> by calling <code>SoftwareInfoSender::setFirmwareVersion()</code>. This code path can be exercised in the <code>SampleApp</code> with the new command: <code>f</code>.</li>
<li>Added unit tests for Alerts.</li>
<li>The GStreamer-based pipeline allows for the configuration of <code>MediaPlayer</code> output based on information provided in <code>Config</code>.</li>
<li>Playlist streaming now uses a <code>BLOCKING</code> writer, which improves streaming efficiency.</li>
</ul>
<p><b>Bug Fixes</b></p><ul>
<li>Fixed bug where <code>SpeechSynthesizer</code> would not stop playback when a state change timeout was encountered.</li>
<li>Fixed the <code>SampleApplication</code> destructor to avoid segfaults if the object is not constructed correctly.</li>
<li>Fixed bug where <code>AudioPlayer</code> would erroneously call <code>executeStop()</code> in <code>cancelDirective()</code>.</li>
<li><a href="https://github.com/alexa/avs-device-sdk/issues/396">Issue 396</a> - Fixed bug for compilation error with GCC7 in <code><a class="el" href="_alerts_audio_factory_interface_8h.html">AVSCommon/SDKInterfaces/include/AVSCommon/SDKInterfaces/Audio/AlertsAudioFactoryInterface.h</a></code></li>
<li><a href="https://github.com/alexa/avs-device-sdk/issues/384">Issue 384</a> - Fixed bug that caused <code>AuthServer.py</code> to crash.</li>
<li>Fixed bug where a long delay was encountered after pausing and resuming a large Audible chapter.</li>
<li>Fixed bug that caused named timers and reminders to loop for an additional <code>loopCount</code> .</li>
<li>Fixed memory corruption bug in <code>MessageInterpreter</code>.</li>
<li>Fixed illegal memory accesses in <code>MediaPlayer</code> logging.</li>
</ul>
<p><b>Known Issues</b></p><ul>
<li>The <code>ACL</code> may encounter issues if audio attachments are received but not consumed.</li>
<li>Display Cards for Kindle don't render.</li>
<li>If using the GStreamer-based <code>MediaPlayer</code> implementation, after muting and un-muting an audio item, the next item in the queue will begin playing rather than continuing playback of the originally muted audio item.</li>
<li><code>SpeechSynthesizerState</code> currently uses <code>GAINING_FOCUS</code> and <code>LOSING_FOCUS</code> as a workaround for handling intermediate state. These states may be removed in a future release.</li>
<li>Music playback doesn't immediately stop when a user barges-in on iHeartRadio.</li>
</ul>
<h3>[1.3.0] - 2017-12-08</h3>
<ul>
<li><b>Enhancements</b><ul>
<li>ContextManager now passes the namespace/name of the desired state to StateProviderInterface::provideState(). This is helpful when a single StateProvider object provides multiple states, and needs to know which one ContextManager is asking for.</li>
<li>The mime parser was hardened against duplicate boundaries.</li>
<li>Added functionality to add and remove AudioPlayer observers to the DefaultClient.</li>
<li>Unit tests for Alerts were added.</li>
<li>Added en-IN, en-CA and ja-JP to the SampleApp locale selection menu.</li>
<li>Added default alert and timer audio data to the SDK SampleApp. There is no longer a requirement to download these audio files and configure them in the json configuration file.</li>
<li>Added support in SDS Reader and AttachmentReader for seeking into the future. This allows a reader to move to an index which has not yet arrived in the SDS and poll/block until it arrives.</li>
<li>Added support for blocking Writers in the SharedDataStream class.</li>
<li>Changed the default status code sent by MessageRequestObserverInterface::onSendCompleted() to SERVER_OTHER_ERROR, and mapped HTTP code 500 to SERVER_INTERNAL_ERROR_V2.</li>
<li>Added support for parsing stream duration out of playlists.</li>
<li>Added a configuration option ("sampleApp":"displayCardsSupported") that allows the displaying of display cards to be enabled or disabled.</li>
<li>Named Timers and Reminders have been updated to fall back to the on-device background audio sound when cloud urls cannot be accessed or rendered.</li>
</ul>
</li>
<li><b>Bug Fixes</b><ul>
<li>Removed floating point dependencies from core SDK libraries.</li>
<li>Fixed bug in SpeechSynthesizer where it's erroneously calling stop more than once.</li>
<li>Fixed an issue in ContentFetcher where it could hang during destruction until an active GET request completed.</li>
<li>Fixed a couple of parsing bugs in LibCurlHttpContentFetcher related to case-sensitivity and mime-type handling.</li>
<li>Fixed a bug where MediaPlayerObserverInterface::onPlaybackResumed() wasn't being called after resuming from a pause with a pending play/resume.</li>
<li>Fixed a bug in LibCurlContentFetcher where it could error out if data is written to the SDS faster than it is consumed.</li>
<li>The GStreamer-based MediaPlayer reference implementation now uses the ACL HTTP configured client.<ul>
<li>An API change has been made to MediaPlayerInterface::setSource(). This method now takes in an optional offset as well to allow for immediately streaming to the offset if possible.</li>
<li>Next and Previous buttons now work with Audible.</li>
<li>Pandora resume stuttering is addressed.</li>
<li>Pausing and resuming Amazon music no longer seeks back to the beginning of the song.</li>
</ul>
</li>
<li>libcurl CURLOPT_NOSIGNAL option is set to 1 (<a href="https://curl.haxx.se/libcurl/c/CURLOPT_NOSIGNAL.html">https://curl.haxx.se/libcurl/c/CURLOPT_NOSIGNAL.html</a>) to avoid crashes observed in SampleApp.</li>
<li>Fixed the timing of the PlaybackReportIntervalEvent and PlaybackReportDelayEvent as specified in the directives.</li>
<li>Fixed potential deadlocks in MediaPlayer during shutdown related to queued callbacks.</li>
<li>Fixed a crash in MediaPlayer that could occur if the network is disconnected during playback.</li>
<li>Fixed a bug where music could keep playing while Alexa is speaking.</li>
<li>Fixed a bug which was causing problems with pause/resume and next/previous with Amazon Music.</li>
<li>Fixed a bug where music could briefly start playing between speaks.</li>
<li>Fixed a bug where HLS playlists would stop streaming after the initial playlist had been played to completion.</li>
<li>Fixed a bug where Audible playback could not advance to the next chapter.</li>
<li>Fixed some occurrences of SDK entering the IDLE state during the transition between Listening and Speaking states.</li>
<li>Fixed a bug where PlaybackFinished events were not reporting the correct offset.<ul>
<li>An API change has been made to MediaPlayerInterface::getOffset(). This method is now required to return the final offset when called after playback has stopped.</li>
</ul>
</li>
<li>Fixed a problem where AIP was erroneously resetting its state upon getting a cancelDirective() callback.</li>
</ul>
</li>
<li><b>Known Issues</b><ul>
<li>Capability agent for Notifications is not included in this release.</li>
<li><code>ACL</code>'s asynchronous receipt of audio attachments may manage resources poorly in scenarios where attachments are received but not consumed.</li>
<li>GUI cards don't show for Kindle.</li>
<li>The new SpeechSynthesizerState state values GAINING_FOCUS and LOSING_FOCUS were added as part of a work-around. The will likely be removed in subsequent releases.</li>
<li>With the gstreamer-based MediaPlayer, after muting and unmuting, the next item starts playing rather than continuing with the current item.</li>
</ul>
</li>
</ul>
<h3>[1.2.1] - 2017-11-16</h3>
<ul>
<li><b>Enhancements</b><ul>
<li>Added comments to <code>AlexaClientSDKConfig.json</code>. These descriptions provide additional guidance for what is expected for each field.</li>
<li>Enabled pause and resume controls for Pandora.</li>
</ul>
</li>
<li><b>Bug Fixes</b><ul>
<li>Bug fix for <a href="https://github.com/alexa/avs-device-sdk/issues/329">issue #329</a> - <code>HTTP2Transport</code> instances no longer leak when <code>SERVER_SIDE_DISCONNECT</code> is encountered.</li>
<li>Bug fix for <a href="https://github.com/alexa/avs-device-sdk/issues/189">issue #189</a> - Fixed a race condition in the <code>Timer</code> class that sometimes caused <code>SpeechSynthesizer</code> to get stuck in the "Speaking" state.</li>
<li>Bug fix for a race condition that caused <code>SpeechSynthesizer</code> to ignore subsequent <code>Speak</code> directives.</li>
<li>Bug fix for corrupted mime attachments.</li>
</ul>
</li>
</ul>
<h3>[1.2.0] - 2017-10-27</h3>
<ul>
<li><b>Enhancements</b><ul>
<li>Updated MediaPlayer to solve stability issues</li>
<li>All capability agents were refined to work with the updated MediaPlayer</li>
<li>Added the TemplateRuntime capability agent</li>
<li>Added the SpeakerManager capability agent</li>
<li>Added a configuration option ("sampleApp":"endpoint") that allows the endpoint that SampleApp connects to to be specified without changing code or rebuilding</li>
<li>Added very verbose capture of libcurl debug information</li>
<li>Added an observer interface to observer audio state changes from AudioPlayer</li>
<li>Added support for StreamMetadataExtracted Event. Stream tags found in the stream are represented in JSON and sent to AVS</li>
<li>Added to the SampleApp a simple GuiRenderer as an observer to the TemplateRuntime Capability Agent</li>
<li>Moved shared libcurl functionality to AVSCommon/Utils</li>
<li>Added a CMake option to exclude tests from the "make all" build. Use "cmake &lt;absolute-path-to-source&gt;
  -DACSDK_EXCLUDE_TEST_FROM_ALL=ON" to enable it. When this option is enabled "make unit" and "make integration" still could be used to build and run the tests</li>
</ul>
</li>
<li><b>Bug fixes</b>:<ul>
<li>Previously scheduled alerts now play following a restart</li>
<li>General stability fixes</li>
<li>Bug fix for CertifiedSender blocking forever if the network goes down while it's trying to send a message to AVS</li>
<li>Fixes for known issue of Alerts integration tests fail: AlertsTest.UserLongUnrelatedBargeInOnActiveTimer and AlertsTest.handleOneTimerWithVocalStop</li>
<li>Attempting to end a tap-to-talk interaction with the tap-to-talk button wouldn't work</li>
<li>SharedDataStream could encounter a race condition due to a combination of a blocking Reader and a Writer closing before writing any data</li>
<li>Bug-fix for the ordering of notifications within alerts scheduling. This fixes the issue where a local-stop on an alert would also stop a subsequent alert if it were to begin without delay</li>
</ul>
</li>
<li><b>Known Issues</b></li>
<li>Capability agent for Notifications is not included in this release</li>
<li>Inconsistent playback behavior when resuming content ("Alexa, pause." / "Alexa, resume."). Specifically, handling playback offsets, which causes the content to play from the start. This behavior is also occasionally seen with "Next" / "Previous".</li>
<li><code>ACL</code>'s asynchronous receipt of audio attachments may manage resources poorly in scenarios where attachments are received but not consumed.</li>
<li>Music playback failures may result in an error Text to Speech being rendered repeatedly</li>
<li>Reminders and named timers don't sound when there is no connection</li>
<li>GUI cards don't show for Kindle</li>
</ul>
<h3>[1.1.0] - 2017-10-02</h3>
<ul>
<li><b>Enhancements</b><ul>
<li>Better GStreamer error reporting. MediaPlayer used to only report <code>MEDIA_ERROR_UNKNOWN</code>, now reports more specific errors as defined in <code><a class="el" href="_error_type_8h.html">ErrorType.h</a></code>.</li>
<li>Codebase has been formatted for easier reading.</li>
<li><code>DirectiveRouter::removeDirectiveHandler()</code> signature changed and now returns a bool indicating if given handler should be successfully removed or not.</li>
<li>Cleanup of raw and shared pointers in the creation of <code>Transport</code> objects.</li>
<li><code>HTTP2Stream</code>s now have IDs assigned as they are acquired as opposed to created, making associated logs easier to interpret.</li>
<li><code>AlertsCapabilityAgent</code> has been refactored.<ul>
<li>Alert management has been factored out into an <code>AlertScheduler</code> class.</li>
</ul>
</li>
<li>Creation of Reminder (implements Alert) class.</li>
<li>Added new capability agent for <code>PlaybackController</code> with unit tests.</li>
<li>Added Settings interface with unit tests.</li>
<li>Return type of <code>getOffsetInMilliseconds()</code> changed from <code>int64_t</code> to <code>std::chronology::milliseconds</code>.</li>
<li>Added <code>AudioPlayer</code> unit tests.</li>
<li>Added teardown for all Integration tests except Alerts.</li>
<li>Implemented PlaylistParser.</li>
</ul>
</li>
<li><b>Bug fixes</b>:<ul>
<li>AIP getting stuck in <code>LISTENING</code> or <code>THINKING</code> and refusing user input on network outage.</li>
<li>SampleApp crashing if running for 5 minutes after network disconnect.</li>
<li>Issue where on repeated user barge-ins, <code>AudioPlayer</code> would not pause. Specifically, the third attempt to “Play iHeartRadio” would not result in currently-playing music pausing.</li>
<li>Utterances being ignored after particularly long TTS.</li>
<li>GStreamer errors cropping up on SampleApp exit as a result of accessing the pipeline before it’s been setup.</li>
<li>Crashing when playing one URL after another.</li>
<li>Buffer overrun in Alerts Renderer.</li>
<li><a href="https://github.com/alexa/avs-device-sdk/issues/153">SampleApp crashing when issuing "Alexa skip" command with iHeartRadio.</a></li>
<li><a href="https://github.com/alexa/avs-device-sdk/issues/127"><code>HTTP2Transport</code> network thread triggering a join on itself.</a></li>
<li><a href="https://github.com/alexa/avs-device-sdk/issues/67"><code>HTTP2Stream</code> request handling truncating exception messages.</a></li>
<li><a href="https://github.com/alexa/avs-device-sdk/issues/138"><code>AudioPlayer</code> was attempting an incorrect state transition from <code>STOPPED</code> to <code>PLAYING</code> through a <code>playbackResumed</code>.</a></li>
</ul>
</li>
<li><b>Known Issues</b></li>
<li>Native components for the following capability agents are <b>not</b> included in this release: <code>Speaker</code>, <code>TemplateRuntime</code>, and <code>Notifications</code></li>
<li><code>ACL</code>'s asynchronous receipt of audio attachments may manage resources poorly in scenarios where attachments are received but not consumed.</li>
<li>When an <code>AttachmentReader</code> does not deliver data for prolonged periods, <code>MediaPlayer</code> may not resume playing the delayed audio.</li>
<li>Without the refresh token in the JSON file, the sample app crashes on start up.</li>
<li>Alerts do not play after restarting the device.</li>
<li>Alexa's responses are cut off by about half a second when asking "What's up" or barging into an active alarm to ask the time.</li>
<li>Switching from Kindle to Amazon Music after pausing and resuming Kindle doesn't work.</li>
<li>Pause/resume on Amazon Music causes entire song to start over.</li>
<li>Stuck in listening state if <code>ExpectSpeech</code> comes in when the microphone has been turned off.</li>
<li>Pausing and resuming Pandora causes stuttering, looped audio.</li>
<li>Audible features are not fully supported.</li>
<li><code>Recognize</code> event after regaining network connection and during an alarm going off can cause client to get stuck in <code>Recognizing</code> state.</li>
<li>Three Alerts integration tests fail: <code>handleMultipleTimersWithLocalStop</code>, <code>AlertsTest.UserLongUnrelatedBargeInOnActiveTimer</code>, <code>AlertsTest.handleOneTimerWithVocalStop</code></li>
<li><code>MediaPlayerTest.testSetOffsetSeekableSource</code> unit test fails intermittently on Linux.</li>
</ul>
<h3>[1.0.3] - 2017-09-19</h3>
<ul>
<li><b>Enhancements</b><ul>
<li>Implemented <code>setOffSet</code> in <code>MediaPlayer</code>.</li>
<li><a href="https://github.com/alexa/avs-device-sdk/issues/77">Updated <code>LoggerUtils.cpp</code></a>.</li>
</ul>
</li>
<li><b>Bug Fixes</b><ul>
<li><a href="https://github.com/alexa/avs-device-sdk/issues/129">Bug fix to address incorrect stop behavior caused when Audio Focus is set to <code>NONE</code> and released</a>.</li>
<li>Bug fix for intermittent failure in <code>handleMultipleConsecutiveSpeaks</code>.</li>
<li>Bug fix for <code>jsonArrayExist</code> incorrectly parsing JSON when trying to locate array children.</li>
<li>Bug fix for ADSL test failures with <code>sendDirectiveWithoutADialogRequestId</code>.</li>
<li>Bug fix for <code>SpeechSynthesizer</code> showing the wrong UX state when a burst of <code>Speak</code> directives are received.</li>
<li>Bug fix for recursive loop in <code>AudioPlayer.Stop</code>.</li>
</ul>
</li>
</ul>
<h3>[1.0.2] - 2017-08-23</h3>
<ul>
<li>Removed code from AIP which propagates ExpectSpeech initiator strings to subsequent Recognize events. This code will be re-introduced when AVS starts sending initiator strings.</li>
</ul>
<h3>[1.0.1] - 2017-08-17</h3>
<ul>
<li>Added a fix to the sample app so that the <code>StateSynchronization</code> event is the first that gets sent to AVS.</li>
<li>Added a <code>POST_CONNECTED</code> enum to <code>ConnectionStatusObserver</code>.</li>
<li><code>StateSychronizer</code> now automatically sends a <code>StateSynchronization</code> event when it receives a notification that <code>ACL</code> is <code>CONNECTED</code>.</li>
<li>Added <code>make install</code> for installing the AVS Device SDK.</li>
<li>Added an optional <code>make networkIntegration</code> for integration tests for slow network (only on Linux platforms).</li>
<li>Added shutdown management which fully cleans up SDK objects during teardown.</li>
<li>Fixed an issue with <code>AudioPlayer</code> barge-in which was preventing subsequent audio from playing.</li>
<li>Changed <code>Mediaplayer</code> buffering to reduce stuttering.</li>
<li>Known Issues:<ul>
<li>Connection loss during listening keeps the app in that state even after connection is regained. Pressing ‘s’ unsticks the state.</li>
<li>Play/Pause media restarts it from the beginning.</li>
<li><code>SpeechSynthesizer</code> shows wrong UX state during a burst of Speaks.</li>
<li>Quitting the sample app while <code>AudioPlayer</code> is playing something causes a segmentation fault.</li>
<li><code>AudioPlayer</code> sending <code>PlaybackPaused</code> during flash briefing.</li>
<li>Long Delay playing live stations on iHeartRadio.</li>
<li>Teardown warnings at the end of integration tests.</li>
</ul>
</li>
</ul>
<h3>[1.0.0] - 2017-08-07</h3>
<ul>
<li>Added <code>AudioPlayer</code> capability agent.<ul>
<li>Supports iHeartRadio.</li>
</ul>
</li>
<li><code>StateSynchronizer</code> has been updated to better enforce that <code>System.SynchronizeState</code> is the first Event sent on a connection to AVS.</li>
<li>Additional tests have been added to <code>ACL</code>.</li>
<li>The <code>Sample App</code> has been updated with several small fixes and improvements.</li>
<li><code>ADSL</code> was updated such that all directives are now blocked while the handling of previous <code>SpeechSynthesizer.Speak</code> directives complete. Because any directive may now be blocked, the <code>preHandleDirective() / handleDirective()</code> path is now used for handling all directives.</li>
<li>Fixes for the following GitHub issues:<ul>
<li><a href="https://github.com/alexa/alexa-client-sdk/issues/44">EXPECTING_SPEECH + SPEAK directive simultaneously on multi-turn conversation</a>.</li>
</ul>
</li>
<li>A bug causing <code>ACL</code> to not send a ping to AVS every 5 minutes, leading to periodic server disconnects, was fixed.</li>
<li>Subtle race condition issues were addressed in the <code>Executor</code> class, resolving some intermittent crashes.</li>
<li>Known Issues<ul>
<li>Native components for the following capability agents are <b>not</b> included in this release: <code>PlaybackController</code>, <code>Speaker</code>, <code>Settings</code>, <code>TemplateRuntime</code>, and <code>Notifications</code>.</li>
<li><code>MediaPlayer</code><ul>
<li>Long periods of buffer underrun can cause an error related with seeking and subsequent stopped playback.</li>
<li>Long periods of buffer underrun can cause flip flopping between buffer_underrun and playing states.</li>
<li>Playlist parsing is not supported unless -DTOTEM_PLPARSER=ON is specified.</li>
</ul>
</li>
<li><code>AudioPlayer</code><ul>
<li>Amazon Music, TuneIn, and SiriusXM are not supported in this release.</li>
<li>Our parsing of urls currently depends upon GNOME/totem-pl-parser which only works on some Linux platforms.</li>
</ul>
</li>
<li><code>AlertsCapabilityAgent</code><ul>
<li>Satisfies the <a href="https://developer.amazon.com/public/solutions/alexa/alexa-voice-service/reference/timers-and-alarms-conceptual-overview">AVS specification</a> except for sending retrospective Events. For example, sending <code>AlertStarted</code> Event for an Alert which rendered when there was no internet connection.</li>
</ul>
</li>
<li><code>Sample App</code>:<ul>
<li>Any connection loss during the <code>Listening</code> state keeps the app stuck in that state, unless the ongoing interaction is manually stopped by the user.</li>
<li>The user must wait several seconds after starting up the sample app before the sample app is properly usable.</li>
</ul>
</li>
<li><code>Tests</code>:<ul>
<li><code>SpeechSynthesizer</code> unit tests hang on some older versions of GCC due to a tear down issue in the test suite</li>
<li>Intermittent Alerts integration test failures caused by rigidness in expected behavior in the tests</li>
</ul>
</li>
</ul>
</li>
</ul>
<h3>[0.6.0] - 2017-07-14</h3>
<ul>
<li>Added a sample app that leverages the SDK.</li>
<li>Added <code>Alerts</code> capability agent.</li>
<li>Added the <code>DefaultClient</code> class.</li>
<li>Added the following classes to support directives and events in the <a href="https://developer.amazon.com/public/solutions/alexa/alexa-voice-service/reference/system"><code>System</code> interface</a>: <code>StateSynchronizer</code>, <code>EndpointHandler</code>, and <code>ExceptionEncounteredSender</code>.</li>
<li>Added unit tests for <code>ACL</code>.</li>
<li>Updated <code>MediaPlayer</code> to play local files given an <code>std::istream</code>.</li>
<li>Changed build configuration from <code>Debug</code> to <code>Release</code>.</li>
<li>Removed <code>DeprecatedLogger</code> class.</li>
<li>Known Issues:<ul>
<li><code>MediaPlayer</code>: Our <code>GStreamer</code> based implementation of <code>MediaPlayer</code> is not fully robust, and may result in fatal runtime errors, under the following conditions:<ul>
<li>Attempting to play multiple simultaneous audio streams</li>
<li>Calling <code>MediaPlayer::play()</code> and <code>MediaPlayer::stop()</code> when the MediaPlayer is already playing or stopped, respectively.</li>
<li>Other miscellaneous issues, which will be addressed in the near future</li>
</ul>
</li>
<li><code>AlertsCapabilityAgent</code>:<ul>
<li>This component has been temporarily simplified to work around the known <code>MediaPlayer</code> issues mentioned above</li>
<li>Fully satisfies the AVS specification except for sending retrospective Events, for example, sending <code>AlertStarted</code> for an Alert which rendered when there was no Internet connection</li>
<li>This component is not fully thread-safe, however, this will be addressed shortly</li>
<li>Alerts currently run indefinitely until stopped manually by the user. This will be addressed shortly by having a timeout value for an alert to stop playing.</li>
<li>Alerts do not play in the background when Alexa is speaking, but will continue playing after Alexa stops speaking.</li>
</ul>
</li>
<li><code>Sample App</code>:<ul>
<li>Without the refresh token being filled out in the JSON file, the sample app crashes on start up.</li>
<li>Any connection loss during the <code>Listening</code> state keeps the app stuck in that state, unless the ongoing interaction is manually stopped by the user.</li>
<li>At the end of a shopping list with more than 5 items, the interaction in which Alexa asks the user if he/she would like to hear more does not finish properly.</li>
</ul>
</li>
</ul>
</li>
</ul>
<p><code>Tests</code>:</p><ul>
<li><code>SpeechSynthesizer</code> unit tests hang on some older versions of GCC due to a tear down issue in the test suite</li>
<li>Intermittent Alerts integration test failures caused by rigidness in expected behavior in the tests</li>
</ul>
<h3>[0.5.0] - 2017-06-23</h3>
<ul>
<li>Updated most SDK components to use new logging abstraction.</li>
<li>Added a <code>getConfiguration()</code> method to <code>DirectiveHandlerInterface</code> to register capability agents with Directive Sequencer.</li>
<li>Added <code>ACL</code> stream processing with pause and redrive.</li>
<li>Removed the dependency of <code>ACL</code> library on <code>Authdelegate</code>.</li>
<li>Added an interface to allow <code>ACL</code> to add/remove <code>ConnectionStatusObserverInterface</code>.</li>
<li>Fixed compile errors in KITT.ai, <code>DirectiveHandler</code> and compiler warnings in <code>AIP</code> tests.</li>
<li>Corrected formatting of code in many files.</li>
<li>Fixes for the following GitHub issues:<ul>
<li><a href="https://github.com/alexa/alexa-client-sdk/issues/21">MessageRequest callbacks never triggered if disconnected</a></li>
<li><a href="https://github.com/alexa/alexa-client-sdk/issues/25">AttachmentReader::read() returns ReadStatus::CLOSED if an AttachmentWriter has not been created yet</a></li>
</ul>
</li>
</ul>
<h3>[0.4.1] - 2017-06-09</h3>
<ul>
<li>Implemented Sensory wake word detector functionality.</li>
<li>Removed the need for a <code>std::recursive_mutex</code> in <code>MessageRouter</code>.</li>
<li>Added <code>AIP</code> unit tests.</li>
<li>Added <code>handleDirectiveImmediately</code> functionality to <code>SpeechSynthesizer</code>.</li>
<li>Added memory profiles for:<ul>
<li>AIP</li>
<li>SpeechSynthesizer</li>
<li>ContextManager</li>
<li>AVSUtils</li>
<li>AVSCommon</li>
</ul>
</li>
<li>Bug fix for <code>MessageRouterTest</code> aborting intermittently.</li>
<li>Bug fix for <code>MultipartParser.h</code> compiler warning.</li>
<li>Suppression of sensitive log data even in debug builds. Use CMake parameter -DACSDK_EMIT_SENSITIVE_LOGS=ON to allow logging of sensitive information in DEBUG builds.</li>
<li>Fixed crash in <code>ACL</code> when attempting to use more than 10 streams.</li>
<li>Updated <code>MediaPlayer</code> to use <code>autoaudiosink</code> instead of requiring <code>pulseaudio</code>.</li>
<li>Updated <code>MediaPlayer</code> build to suppport local builds of GStreamer.</li>
<li>Fixes for the following GitHub issues:<ul>
<li><a href="https://github.com/alexa/alexa-client-sdk/issues/5">MessageRouter::send() does not take the m_connectionMutex</a></li>
<li><a href="https://github.com/alexa/alexa-client-sdk/issues/8">MessageRouter::disconnectAllTransportsLocked flow leads to erase while iterating transports vector</a></li>
<li><a href="https://github.com/alexa/alexa-client-sdk/issues/9">Build errors when building with KittAi enabled</a></li>
<li><a href="https://github.com/alexa/alexa-client-sdk/issues/10">HTTP2Transport race may lead to deadlock</a></li>
<li><a href="https://github.com/alexa/alexa-client-sdk/issues/17">Crash in HTTP2Transport::cleanupFinishedStreams()</a></li>
<li><a href="https://github.com/alexa/alexa-client-sdk/issues/24">The attachment writer interface should take a <code>const void*</code> instead of <code>void*</code></a></li>
</ul>
</li>
</ul>
<h3>[0.4.0] - 2017-05-31 (patch)</h3>
<ul>
<li>Added <code>AuthServer</code>, an authorization server implementation used to retrieve refresh tokens from LWA.</li>
</ul>
<h3>[0.4.0] - 2017-05-24</h3>
<ul>
<li>Added <code>SpeechSynthesizer</code>, an implementation of the <code>SpeechRecognizer</code> capability agent.</li>
<li>Implemented a reference <code>MediaPlayer</code> based on <a href="https://gstreamer.freedesktop.org/">GStreamer</a> for audio playback.</li>
<li>Added <code>MediaPlayerInterface</code> that allows you to implement your own media player.</li>
<li>Updated <code>ACL</code> to support asynchronous receipt of audio attachments from AVS.</li>
<li>Bug Fixes:<ul>
<li>Some intermittent unit test failures were fixed.</li>
</ul>
</li>
<li>Known Issues:<ul>
<li><code>ACL</code>'s asynchronous receipt of audio attachments may manage resources poorly in scenarios where attachments are received but not consumed.</li>
<li>When an <code>AttachmentReader</code> does not deliver data for prolonged periods <code>MediaPlayer</code> may not resume playing the delayed audio.</li>
</ul>
</li>
</ul>
<h3>[0.3.0] - 2017-05-17</h3>
<ul>
<li>Added the <code>CapabilityAgent</code> base class that is used to build capability agent implementations.</li>
<li>Added <code>ContextManager</code>, a component that allows multiple capability agents to store and access state. These Events include <code>Context</code>, which is used to communicate the state of each capability agent to AVS in the following Events:<ul>
<li><a href="https://developer.amazon.com/public/solutions/alexa/alexa-voice-service/reference/speechrecognizer#recognize"><code>Recognize</code></a></li>
<li><a href="https://developer.amazon.com/public/solutions/alexa/alexa-voice-service/reference/playbackcontroller#playcommandissued"><code>PlayCommandIssued</code></a></li>
<li><a href="https://developer.amazon.com/public/solutions/alexa/alexa-voice-service/reference/playbackcontroller#pausecommandissued"><code>PauseCommandIssued</code></a></li>
<li><a href="https://developer.amazon.com/public/solutions/alexa/alexa-voice-service/reference/playbackcontroller#nextcommandissued"><code>NextCommandIssued</code></a></li>
<li><a href="https://developer.amazon.com/public/solutions/alexa/alexa-voice-service/reference/playbackcontroller#previouscommandissued"><code>PreviousCommandIssued</code></a></li>
<li><a href="https://developer.amazon.com/public/solutions/alexa/alexa-voice-service/reference/system#synchronizestate"><code>SynchronizeState</code></a></li>
<li><a href="https://developer.amazon.com/public/solutions/alexa/alexa-voice-service/reference/system#exceptionencountered"><code>ExceptionEncountered</code></a></li>
</ul>
</li>
<li>Added <code>SharedDataStream</code> (SDS) to asynchronously communicate data between a local reader and writer.</li>
<li>Added <code>AudioInputProcessor</code> (AIP), an implementation of a <code>SpeechRecognizer</code> capability agent.</li>
<li>Added WakeWord Detector (WWD), which recognizes keywords in audio streams. [0.3.0] implements a wrapper for KITT.ai.</li>
<li>Added a new implementation of <code>AttachmentManager</code> and associated classes for use with SDS.</li>
<li>Updated <code>ACL</code> to support asynchronously sending audio to AVS.</li>
</ul>
<h3>[0.2.1] - 2017-05-03</h3>
<ul>
<li>Replaced the configuration file <code>AuthDelegate.config</code> with <code>AlexaClientSDKConfig.json</code>.</li>
<li>Added the ability to specify a <code>CURLOPT_CAPATH</code> value to be used when libcurl is used by ACL and AuthDelegate. See See Appendix C in the README for details.</li>
<li>Changes to ADSL interfaces:<ul>
<li>The [0.2.0] interface for registering directive handlers (<code>DirectiveSequencer::setDirectiveHandlers()</code>) was problematic because it canceled the ongoing processing of directives and dropped further directives until it completed. The revised API makes the operation immediate without canceling or dropping any handling. However, it does create the possibility that <code>DirectiveHandlerInterface</code> methods <code>preHandleDirective()</code> and <code>handleDirective()</code> may be called on different handlers for the same directive.</li>
<li><code>DirectiveSequencerInterface::setDirectiveHandlers()</code> was replaced by <code>addDirectiveHandlers()</code> and <code>removeDirectiveHandlers()</code>.</li>
<li><code>DirectiveHandlerInterface::shutdown()</code> was replaced with <code>onDeregistered()</code>.</li>
<li><code>DirectiveHandlerInterface::preHandleDirective()</code> now takes a <code>std::unique_ptr</code> instead of a <code>std::shared_ptr</code> to <code>DirectiveHandlerResultInterface</code>.</li>
<li><code>DirectiveHandlerInterface::handleDirective()</code> now returns a bool indicating if the handler recognizes the <code>messageId</code>.</li>
</ul>
</li>
<li>Bug fixes:<ul>
<li>ACL and AuthDelegate now require TLSv1.2.</li>
<li><code>onDirective()</code> now sends <code>ExceptionEncountered</code> for unhandled directives.</li>
<li><code>DirectiveSequencer::shutdown()</code> no longer sends <code>ExceptionEncountered()</code> for queued directives.</li>
</ul>
</li>
</ul>
<h3>[0.2.0] - 2017-03-27 (patch)</h3>
<ul>
<li>Added memory profiling for ACL and ADSL. See Appendix A in the README.</li>
<li>Added a command to build the API documentation.</li>
</ul>
<h3>[0.2.0] - 2017-03-09</h3>
<ul>
<li>Added <code>Alexa Directive Sequencer Library</code> (ADSL) and <code>Alexa Focus Manager Library</code> (AMFL).</li>
<li>CMake build types and options have been updated.</li>
<li>Documentation for libcurl optimization included.</li>
</ul>
<h3>[0.1.0] - 2017-02-10</h3>
<ul>
<li>Initial release of the <code>Alexa Communications Library</code> (ACL), a component which manages network connectivity with AVS, and <code>AuthDelegate</code>, a component which handles user authorization with AVS. </li>
</ul>
</div></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.7.1 - Copyright 2016-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
